var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import React from 'react';
import styled from 'styled-components';
import { Box, Segment } from '../elements';
import { Loader } from '../modules';
import { useWidget } from './widgets';
var WidgetContent = function (_a) {
    var config = _a.config;
    var Component = useWidget(config.as);
    return React.createElement(Component, { config: config }, config.content);
};
var WidgetSegment = styled(Segment)({
    overflowY: 'auto',
    margin: 0,
    display: 'flex',
    flexFlow: 'column nowrap',
    alignItems: 'stretch',
    justifyContent: 'center',
    '& > small': {
        paddingBottom: '1em',
        textAlign: 'center',
    },
});
var ResponsiveBox = styled(Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  height: unset;\n  width: 50%;\n  flex: 1 1 ", ";\n"], ["\n  height: unset;\n  width: 50%;\n  flex: 1 1 ", ";\n"])), function (_a) {
    var itemSize = _a.itemSize;
    return itemSize || 'auto';
});
// Disable scaling in Box
ResponsiveBox.defaultProps = {
    width: 200,
    height: 200,
};
export var Widget = function (_a) {
    var config = _a.config;
    return (React.createElement(ResponsiveBox, { itemSize: config.size, padded: true, stretched: true },
        React.createElement(WidgetSegment, { raised: !config.basic, color: config.backgroundColor },
            config.title && React.createElement("small", null, config.title),
            React.createElement(React.Suspense, { fallback: React.createElement(Loader, { active: true }) },
                React.createElement(WidgetContent, { config: config })))));
};
var templateObject_1;
